/*  fgwirc - fungw based minimal irc client
    Copyright (C) 2019  Tibor 'Igor2' Palinkas

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

    Project page and contact: http://repo.hu/projects/fgwirc
*/

#include <string.h>

#include "target.h"

#define HT(x) httw_ ## x
#include "genht/ht.c"
#undef HT

#include "genht/hash.h"

int httw_keyeq(httw_const_key_t a, httw_const_key_t b)
{
	if (a->type != b->type) return 0;
	if (a->sid != b->sid) return 0;
	if ((a->name == NULL) && (b->name != NULL)) return 0;
	if ((a->name != NULL) && (b->name == NULL)) return 0;
	if ((a->name == NULL) && (b->name == NULL)) return 1;
	return !genht_strcasecmp(a->name, b->name);
}

unsigned httw_keyhash(httw_const_key_t k)
{
	return ((k->name == NULL) ? 0 : strhash_case(k->name)) ^ ((unsigned)k->sid) << 8  ^ ((unsigned)k->type) << 16;
}
